"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _helperPluginUtils = require("@babel/helper-plugin-utils");

var _utils = _interopRequireDefault(require("./utils"));

var _flowFiles = _interopRequireDefault(require("./flowFiles"));

var _writeFiles = _interopRequireDefault(require("./writeFiles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (0, _helperPluginUtils.declare)(function (api, options) {
  api.assertVersion(7);

  _utils.default.initializeOptions(options);

  return {
    manipulateOptions: _utils.default.manipulateOptions,
    visitor: {
      ImportDeclaration: function ImportDeclaration(_ref, _ref2) {
        var value = _ref.node.source.value;
        var cwd = _ref2.cwd,
            filename = _ref2.filename;
        if (!/\.js\.flow$/.test(value)) return;

        var filePath = _path.default.resolve(filename, '..', value);

        var _utils$getFilePaths = _utils.default.getFilePaths(filePath, cwd),
            srcPath = _utils$getFilePaths.srcPath,
            destPath = _utils$getFilePaths.destPath;

        if (_flowFiles.default.fileExist(srcPath)) return;

        _flowFiles.default.add({
          srcPath: srcPath,
          destPath: destPath,
          filePath: filePath,
          babelConfigs: {
            parserOpts: {},
            notInitialized: true
          }
        });
      }
    },
    post: function post(_ref3) {
      var _ref3$opts = _ref3.opts,
          cwd = _ref3$opts.cwd,
          filename = _ref3$opts.filename,
          plugins = _ref3$opts.parserOpts.plugins;
      var configs = _utils.default.options.configs;

      var _utils$getFilePaths2 = _utils.default.getFilePaths(filename, cwd),
          srcPath = _utils$getFilePaths2.srcPath,
          destPath = _utils$getFilePaths2.destPath;

      var babelConfigs = _objectSpread({}, configs, {
        parserOpts: _objectSpread({
          plugins: plugins
        }, configs === null || configs === void 0 ? void 0 : configs.parserOpts)
      });

      _flowFiles.default.store.forEach(function (flowFile) {
        if (flowFile.babelConfigs.notInitialized) {
          delete flowFile.babelConfigs.notInitialized;
          flowFile.babelConfigs = babelConfigs;

          _writeFiles.default.add(flowFile);
        }
      });

      var flowFilePath = filename.replace(/\.js$/, '.js.flow');
      var flowSrcPath = srcPath.replace(/\.js$/, '.js.flow');

      if (_fs.default.existsSync(flowFilePath)) {
        if (!_flowFiles.default.fileExist(flowSrcPath)) {
          var flowFile = {
            srcPath: flowSrcPath,
            destPath: destPath,
            filePath: flowFilePath,
            babelConfigs: babelConfigs
          };

          _flowFiles.default.add(flowFile);

          _writeFiles.default.add(flowFile);
        }

        return;
      }

      _writeFiles.default.add({
        srcPath: srcPath,
        destPath: destPath,
        babelConfigs: babelConfigs
      });
    }
  };
});

exports.default = _default;
module.exports = exports["default"];