"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@babel/core");

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _utils = _interopRequireDefault(require("./utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @example
 * new WriteFiles()
 */
var WriteFiles = function WriteFiles() {
  var _this = this;

  _classCallCheck(this, WriteFiles);

  _defineProperty(this, "store", []);

  _defineProperty(this, "isWritting", false);

  _defineProperty(this, "add", function (file) {
    _this.store.push(file);

    if (!_this.isWritting) _this.writeFiles();
  });

  _defineProperty(this, "writeFiles", function () {
    _this.isWritting = true;
    var _utils$options = _utils.default.options,
        verbose = _utils$options.verbose,
        watch = _utils$options.watch;

    var _this$store$pop = _this.store.pop(),
        srcPath = _this$store$pop.srcPath,
        destPath = _this$store$pop.destPath,
        babelConfigs = _this$store$pop.babelConfigs;

    try {
      var _transformFileSync = (0, _core.transformFileSync)(srcPath, babelConfigs),
          code = _transformFileSync.code;

      _this.store = _this.store.filter(function (writeFile) {
        return writeFile.srcPath !== srcPath;
      });
      (0, _outputFileSync.default)(destPath, code);
      _this.isWritting = false; // eslint-disable-next-line no-console

      if (verbose) console.log("".concat(srcPath, " -> ").concat(destPath));
      if (_this.store.length !== 0) _this.writeFiles();
    } catch (e) {
      var errorMessage = "@cat-org/babel-plugin-transform-flow ".concat(e);
      _this.isWritting = false; // eslint-disable-next-line no-console

      if (watch) console.log(errorMessage);else throw new Error(errorMessage);
    }
  });
};

var _default = new WriteFiles();

exports.default = _default;
module.exports = exports["default"];